module     uussbb_d208h2l1
   ! file:      /home/thomasr/Work/samurai-processes/uussbb/helicity2/d208h2l1.f
   ! 90
   ! generator: haggies (1.1)
   use precision, only: ki
   use uussbb_config
   use uussbb_model
   use uussbb_kinematics
   use uussbb_util, only: cond
   use uussbb_color
   use uussbb_abbrevh2l1
   implicit none
   
   private :: brack_1
   private :: brack_2
   private :: brack_3
   private :: brack_4
   private :: brack_5

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   private :: i_

contains
   pure function brack_1(Q, mu2) result(brack)
      implicit none
      complex(ki), dimension(4), intent(in) :: Q
      real(ki), intent(in) :: mu2
      complex(ki) :: brack
      
      brack = (abb208n1/(es12+es34-(es56+es345))*i_)
   end  function brack_1
   pure function brack_2(Q, mu2) result(brack)
      implicit none
      complex(ki), dimension(4), intent(in) :: Q
      real(ki), intent(in) :: mu2
      complex(ki), dimension(numcs) :: brack
      real(ki) :: t1
      
      t1 = NC*NC
      brack = (TR*TR*TR*((2.0_ki)*(c3/NC-c2/t1)+(-((1.0_ki)/t1+(1.0_ki)))*c4+((1&
      &.0_ki)/(t1*NC)+(1.0_ki)/NC)*c1))
   end  function brack_2
   pure function brack_3(Q, mu2) result(brack)
      implicit none
      complex(ki), dimension(4), intent(in) :: Q
      real(ki), intent(in) :: mu2
      complex(ki) :: brack
      
      brack = ((8.0_ki)*((2.0_ki)*abb208n7*dotproduct(Q, k3)-abb208n7*dotproduct&
      &(Q, Q))+(4.0_ki)*(abb208n6+mu2*abb208n7+abb208n2*dotproduct(Q, spvak1k4)+&
      &abb208n3*dotproduct(Q, spvak1k6)+abb208n5*dotproduct(Q, spvak5k4)+abb208n&
      &7*es345+abb208n8*dotproduct(Q, spvak5k6)+abb208n9*dotproduct(Q, spvak3k4)&
      &-(abb208n7*es45+abb208n7*es34+abb208n11*dotproduct(Q, spvak3k6))))
   end  function brack_3
   pure function brack_4(Q, mu2) result(brack)
      implicit none
      complex(ki), dimension(4), intent(in) :: Q
      real(ki), intent(in) :: mu2
      complex(ki) :: brack
      complex(ki) :: t1
      
      t1 = dotproduct(Q, spvak3k4)
      brack = ((2.0_ki)*(t1*abb208n12*dotproduct(Q, spvak5k6)+t1*abb208n4*dotpro&
      &duct(Q, spvak1k6)-t1*abb208n10))
   end  function brack_4
   pure function brack_5(Q, mu2) result(brack)
      implicit none
      complex(ki), dimension(4), intent(in) :: Q
      real(ki), intent(in) :: mu2
      integer :: brack
      
      brack = 0
   end  function brack_5

   pure subroutine diagram208(Q, mu2, epspow, res)
      implicit none
      complex(ki), dimension(4), intent(in) :: Q
      real(ki), intent(in) :: mu2
      integer, intent(in) :: epspow
      complex(ki), dimension(1:numcs), intent(inout) :: res

      complex(ki), dimension(1:numcs) :: acc
      complex(ki) :: prefactor
      complex(ki), dimension(numcs) :: cf1
      ! res is set to zero in the calling routines,
      ! therefore we sum to whatever is there already.
      
      acc = 0.0_ki
      prefactor = brack_1(Q, mu2)
      cf1 = brack_2(Q, mu2)
      acc(:) = acc(:) + cf1(:) * ((cond(epspow.eq.0,brack_3,Q,mu2)+cond(epspow.e&
      &q.1,brack_4,Q,mu2)))
      ! d208: if non-zero, there is only one color structure
      acc(1) = acc(1) + (brack_5(Q, mu2))
      res = res + prefactor * acc
   end  subroutine diagram208
end module uussbb_d208h2l1
