module     uussbb_d255h2l1
   ! file:      /home/thomasr/Work/samurai-processes/uussbb/helicity2/d255h2l1.f
   ! 90
   ! generator: haggies (1.1)
   use precision, only: ki
   use uussbb_config
   use uussbb_model
   use uussbb_kinematics
   use uussbb_util, only: cond
   use uussbb_color
   use uussbb_abbrevh2l1
   implicit none
   
   private :: brack_1
   private :: brack_2
   private :: brack_3
   private :: brack_4
   private :: brack_5

   complex(ki), parameter :: i_ = (0.0_ki, 1.0_ki)
   private :: i_

contains
   pure function brack_1(Q, mu2) result(brack)
      implicit none
      complex(ki), dimension(4), intent(in) :: Q
      real(ki), intent(in) :: mu2
      complex(ki) :: brack
      
      brack = i_
   end  function brack_1
   pure function brack_2(Q, mu2) result(brack)
      implicit none
      complex(ki), dimension(4), intent(in) :: Q
      real(ki), intent(in) :: mu2
      complex(ki), dimension(numcs) :: brack
      real(ki) :: t1
      
      t1 = NC*NC
      brack = (TR*TR*TR*((-((1.0_ki)/t1+(1.0_ki)))*c4+c1/(t1*NC)+(2.0_ki)/NC*c3+&
      &c5/NC-(c6/t1+c2/t1)))
   end  function brack_2
   pure function brack_3(Q, mu2) result(brack)
      implicit none
      complex(ki), dimension(4), intent(in) :: Q
      real(ki), intent(in) :: mu2
      complex(ki) :: brack
      complex(ki) :: t1
      complex(ki) :: t2
      complex(ki) :: t3
      complex(ki) :: t4
      complex(ki) :: t5
      complex(ki) :: t6
      
      t1 = dotproduct(Q, Q)
      t2 = dotproduct(Q, spvak3k5)
      t3 = dotproduct(Q, spvak3k2)
      t4 = dotproduct(Q, spvak5k2)
      t5 = t4*abb255n5
      t6 = t5+abb255n4
      brack = ((8.0_ki)*(t1*abb255n2+abb255n2*dotproduct(Q, k1))+(4.0_ki)*(t2*ab&
      &b255n6+abb255n3*dotproduct(Q, spvak3k1)+t1*t3*abb255n10+t2*t4*abb255n10)+&
      &(4.0_ki)*(-(abb255n4+t5))*es234+((2.0_ki)*(abb255n8+t3*abb255n10+abb255n7&
      &*dotproduct(Q, spvak3k6)-t5)-(abb255n9*dotproduct(Q, spvak3k4)+abb255n12*&
      &dotproduct(Q, spvak1k2)+abb255n1*dotproduct(Q, spvak5k6)))*mu2+(4.0_ki)*t&
      &6*es56+(4.0_ki)*t6*es61)
   end  function brack_3
   pure function brack_4(Q, mu2) result(brack)
      implicit none
      complex(ki), dimension(4), intent(in) :: Q
      real(ki), intent(in) :: mu2
      complex(ki) :: brack
      complex(ki) :: t1
      complex(ki) :: t2
      
      t1 = dotproduct(Q, spvak1k2)
      t2 = dotproduct(Q, spvak5k6)
      brack = (-(t1*t2*dotproduct(Q, spvak3k4)+t1*t2*abb255n11))
   end  function brack_4
   pure function brack_5(Q, mu2) result(brack)
      implicit none
      complex(ki), dimension(4), intent(in) :: Q
      real(ki), intent(in) :: mu2
      integer :: brack
      
      brack = 0
   end  function brack_5

   pure subroutine diagram255(Q, mu2, epspow, res)
      implicit none
      complex(ki), dimension(4), intent(in) :: Q
      real(ki), intent(in) :: mu2
      integer, intent(in) :: epspow
      complex(ki), dimension(1:numcs), intent(inout) :: res

      complex(ki), dimension(1:numcs) :: acc
      complex(ki) :: prefactor
      complex(ki), dimension(numcs) :: cf1
      ! res is set to zero in the calling routines,
      ! therefore we sum to whatever is there already.
      
      acc = 0.0_ki
      prefactor = brack_1(Q, mu2)
      cf1 = brack_2(Q, mu2)
      acc(:) = acc(:) + cf1(:) * ((cond(epspow.eq.0,brack_3,Q,mu2)+cond(epspow.e&
      &q.1,brack_4,Q,mu2)))
      ! d255: if non-zero, there is only one color structure
      acc(1) = acc(1) + (brack_5(Q, mu2))
      res = res + prefactor * acc
   end  subroutine diagram255
end module uussbb_d255h2l1
