module mgetqs
   use precision
   use constants
   use mfunctions
   implicit none

contains
      subroutine getq5(nleg,cut5,e1,e2,e3,e4,p0,Vi,msq,r1,r2,q5,mu2)
      implicit none
      integer cut5,j1,j2,j3,j4,j5,i,nleg
      real(ki) :: r1, r2, x1, x2, mu2, var2, var3
      real(ki) :: MP12, MP1v2, MP1v3, MP2v2, MP2v3, MPv22, MPv33
      real(ki), dimension(4) :: e1, e2, v2, v3, p0
      real(ki), dimension(0:nleg-1):: msq
      real(ki), dimension(0:nleg-1,4) ::Vi
      complex(ki) :: MP3v2, MP3v3, MP4v2, MP4v3, x3, x4, tmu2, den
      complex(ki), dimension(4) :: q5, e3, e4

      j5=cut5/10000
      j4=(cut5-j5*10000)/1000
      j3=(cut5-j5*10000-j4*1000)/100
      j2=(cut5-j5*10000-j4*1000-j3*100)/10
      j1= cut5-j5*10000-j4*1000-j3*100-j2*10

      do i=1,4
         v2(i)=Vi(j3,i)-p0(i)
         v3(i)=Vi(j4,i)-p0(i)
      enddo

      MP12 =sdot(e1,e2)
      MP1v2=sdot(v2,e1)
      MP1v3=sdot(v3,e1)
      MP2v2=sdot(v2,e2)
      MP2v3=sdot(v3,e2)
      MP3v2=sdot(v2,e3)
      MP3v3=sdot(v3,e3)
      MP4v2=sdot(v2,e4)
      MP4v3=sdot(v3,e4)
      MPv22=sdot(v2,v2)
      MPv33=sdot(v3,v3)

      den = -(MP3v3*MP4v2*two) + MP3v2*MP4v3*two

      x1 = (half*(  -(MP12*(1+r1)*r2*two)-(1+r2)*msq(j1) &
     & +r2*msq(j2) + msq(j5)))/(MP12*(-1 + r1*r2))

      x2 = -((half*(-(MP12*r1*(1+r2)*two)-(1+r1)*msq(j1) &
     & +msq(j2) + r1*msq(j5)))/(MP12*(-1 + r1*r2)))

      var2 = MPv22 + MP1v2*two*x1 + MP2v2*two*x2+msq(j1)-msq(j3)
      var3 = MPv33 + MP1v3*two*x1 + MP2v3*two*x2+msq(j1)-msq(j4)

      x3 = (-MP4v3*var2+MP4v2*var3)/den

      x4 = ( MP3v3*var2-MP3v2*var3)/den

      tmu2=two*MP12*(x1*x2-x3*x4)-msq(j1)
      mu2=real(tmu2)
      do i=1,4
         q5(i)=-p0(i)+x1*e1(i)+x2*e2(i)+x3*e3(i)+x4*e4(i)
      enddo
  end subroutine getq5


      subroutine getq4(nleg,cut4,e1,e2,e3,e4,p0,k1,k2,k3,L3,r1,r2,&
     & q1,q2,q3,q4,q5,qt,msq)
      implicit none
      integer cut4,j1,j2,j3,j4,i,nleg
      real(ki) :: r1,r2,beta,mu2,mu2x,x1,x2,A1,A2,mp12
      real(ki), dimension(4) :: k1, k2, k3, L3, e1, e2, p0
      real(ki), dimension(0:nleg-1):: msq
      complex(ki) :: x31,x32,x33,x34,x35,x3t,x41,x42,x43,x44,x45,x4t
      complex(ki) :: ME31,ME32,ME33,ME34,MK11,MK22,MK33,ML33,ML34
      complex(ki) :: dx1,dx2,dx3,dx4,dx5,B0,B1,B2,rtdel,A3,A4
      complex(ki), dimension(4) :: q1, q2, q3, q4, q5, qt, e3, e4

      common/ds/dx1,dx2,dx3,dx4,dx5
      common/mp12mu2/MP12,mu2

      j4=cut4/1000
      j3=(cut4-j4*1000)/100
      j2=(cut4-j4*1000-j3*100)/10
      j1= cut4-j4*1000-j3*100-j2*10

      MP12=sdot(e1,e2)
      ML33=sdot(L3,e3)
      ML34=sdot(L3,e4)
      ME31=sdot(k3,e1)
      ME32=sdot(k3,e2)
      ME33=sdot(k3,e3)
      ME34=sdot(k3,e4)
      MK11=sdot(k1,k1)
      MK22=sdot(k2,k2)
      MK33=sdot(k3,k3)
      beta=one/(one-r1*r2)
      A1=(msq(j2)-msq(j1)-MK11)/two/MP12
      A2=(msq(j1)-msq(j4)+MK22)/two/MP12
      x1=beta*(A2-r2*A1)
      x2=beta*(A1-r1*A2)
      A3=(msq(j3)-msq(j1)-MK33-2d0*x1*ME31-2d0*x2*ME32)/2d0/ME33
      A4=-ME34/ME33
      B1=-two*MP12*A3
      B2=-two*MP12*A4

      mu2=zip
      B0=(two*x1*x2*MP12-msq(j1)-mu2)*cone
      rtdel=sqrt(B1**2-four*B0*B2)
      x41=(-B1+rtdel)/two/B2
      x42=(-B1-rtdel)/two/B2
      x31=x41*A4+A3
      x32=x42*A4+A3
      do i=1,4
         q1(i)=-p0(i)+x1*e1(i)+x2*e2(i)+x31*e3(i)+x41*e4(i)
         q2(i)=-p0(i)+x1*e1(i)+x2*e2(i)+x32*e3(i)+x42*e4(i)
      enddo

!--- scelta dinamica
      mu2=max(msq(j1),msq(j2),msq(j3),msq(j4),&
     & abs(MK11),abs(MK22),abs(MK33),&
     & abs(two*sdot(k1,k2)),abs(two*sdot(k2,k3)),abs(two*sdot(k1,k3)),&
     & abs(two*MP12))

      if (mu2.lt.1.0e-10_ki) mu2=one

!--- scelta statica
!      mu2=one

      B0=(two*x1*x2*MP12-msq(j1)-mu2)*cone
      rtdel=sqrt(B1**2-four*B0*B2)
      x43=(-B1+rtdel)/two/B2
      x44=(-B1-rtdel)/two/B2
      x33=x43*A4+A3
      x34=x44*A4+A3
      do i=1,4
         q3(i)=-p0(i)+x1*e1(i)+x2*e2(i)+x33*e3(i)+x43*e4(i)
         q4(i)=-p0(i)+x1*e1(i)+x2*e2(i)+x34*e3(i)+x44*e4(i)
      enddo

      mu2x=-mu2
      B0=(two*x1*x2*MP12-msq(j1)-mu2x)*cone
      rtdel=sqrt(B1**2-four*B0*B2)
      x45=(-B1+rtdel)/two/B2
!      x45=(-B1-rtdel)/two/B2
      x35=x45*A4+A3
!      x35=x4t*A4+A3
      do i=1,4
         q5(i)=-p0(i)+x1*e1(i)+x2*e2(i)+x35*e3(i)+x45*e4(i)
      enddo

      mu2x=half
      B0=(two*x1*x2*MP12-msq(j1)-mu2x)*cone
      rtdel=sqrt(B1**2-four*B0*B2)
!      x4t=(-B1+rtdel)/two/B2
      x4t=(-B1-rtdel)/two/B2
!      x3t=x45*A4+A3
      x3t=x4t*A4+A3
      do i=1,4
         qt(i)=-p0(i)+x1*e1(i)+x2*e2(i)+x3t*e3(i)+x4t*e4(i)
      enddo

      dx1=ML33*x31-ML34*x41
      dx2=ML33*x32-ML34*x42
      dx3=ML33*x33-ML34*x43
      dx4=ML33*x34-ML34*x44
      dx5=ML33*x35-ML34*x45

  end subroutine getq4

      subroutine getq3(nleg,cut3,e1,e2,e3,e4,p0,k1,k2,msq,r1,r2,&
     & q1,q2,q3,q4,q5,q6,q7,q8,q9,q10,qt)
      implicit none
      integer cut3,j1,j2,j3,i,j,nleg
      real(ki) :: r1,r2,beta,teta,x1,x2,A1,A2,C0,C1,C1t
      real(ki) :: MP12,MK11,MK12,MK22,x3t,x4t,mu2,KK,mu2t
      real(ki), dimension(4) :: p0, k1, k2, e1, e2
      real(ki), dimension(0:nleg-1):: msq
      complex(ki) :: Kmu
      complex(ki), dimension(4) :: q1,q2,q3,q4,q5,q6,q7,q8,q9,q10
      complex(ki), dimension(4) :: qt, e3, e4
      complex(ki), dimension(10) :: x3, x4

      common/C0C1/C0,C1,mu2,MP12,KK,Kmu

      KK=one
      Kmu=one

      j3=cut3/100
      j2=(cut3-j3*100)/10
      j1=cut3-j3*100-j2*10

      MP12=sdot(e1,e2)
      MK11=sdot(k1,k1)
      MK12=sdot(k1,k2)
      MK22=sdot(k2,k2)
      beta=1d0/(1d0-r1*r2)
      A1=(msq(j2)-msq(j1)-MK11)/two/MP12
      A2=(msq(j1)-msq(j3)+MK22)/two/MP12
      x1=beta*(A2-r2*A1)
      x2=beta*(A1-r1*A2)

      C0=x1*x2-msq(j1)/two/MP12

!--- scelta dinamica
      mu2=max(msq(j1),msq(j2),msq(j3),&
     & abs(MK11),abs(MK22),abs(two*MK12))

      if (mu2.lt.1d-10) mu2=one

!--- scelta statica
!      mu2=one

      C1=x1*x2-(msq(j1)+mu2)/two/MP12

      do j=1,4
      teta=twopi/four
      x3(j)=cos(teta*real(j-1,ki))-im*sin(teta*real(j-1,ki))
      x4(j)=C0*cone/x3(j)
      enddo

      do j=5,7
      teta=twopi/three
      x4(j)=cos(teta*real(j-5,ki))+im*sin(teta*real(j-5,ki))
      x3(j)=C0*cone/x4(j)
      enddo

      do j=8,10
      teta=twopi/three
      x4(j)=cos(teta*real(j-8,ki))+im*sin(teta*real(j-8,ki))
      x3(j)=C1*cone/x4(j)
      enddo

      mu2t=half
      C1t=x1*x2-(msq(j1)+mu2t)/two/MP12
      x3t=32.4_ki
      x4t=C1t*cone/x3t

      do i=1,4
      q1(i)=-p0(i)+x1*e1(i)+x2*e2(i)+KK*x3(1)*e3(i)+x4(1)*e4(i)/KK
      q2(i)=-p0(i)+x1*e1(i)+x2*e2(i)+KK*x3(2)*e3(i)+x4(2)*e4(i)/KK
      q3(i)=-p0(i)+x1*e1(i)+x2*e2(i)+KK*x3(3)*e3(i)+x4(3)*e4(i)/KK
      q4(i)=-p0(i)+x1*e1(i)+x2*e2(i)+KK*x3(4)*e3(i)+x4(4)*e4(i)/KK
      q5(i)=-p0(i)+x1*e1(i)+x2*e2(i)+KK*x3(5)*e3(i)+x4(5)*e4(i)/KK
      q6(i)=-p0(i)+x1*e1(i)+x2*e2(i)+KK*x3(6)*e3(i)+x4(6)*e4(i)/KK
      q7(i)=-p0(i)+x1*e1(i)+x2*e2(i)+KK*x3(7)*e3(i)+x4(7)*e4(i)/KK
      q8(i)=-p0(i)+x1*e1(i)+x2*e2(i)+Kmu*x3(8)*e3(i)+x4(8)*e4(i)/Kmu
      q9(i)=-p0(i)+x1*e1(i)+x2*e2(i)+Kmu*x3(9)*e3(i)+x4(9)*e4(i)/Kmu
      q10(i)=-p0(i)+x1*e1(i)+x2*e2(i)+Kmu*x3(10)*e3(i)+x4(10)*e4(i)/Kmu
      qt(i)=-p0(i)+x1*e1(i)+x2*e2(i)+x3t*e3(i)+x4t*e4(i)
      enddo

  end subroutine getq3


      subroutine getq2(nleg,cut2,e1,e2,e3,e4,p0,k1,msq,&
     & q1,q2,q3,q4,q5,q6,q7,q8,q9,q10,qt)
      implicit none
      integer cut2,j1,j2,i,j,nleg
      real(ki), dimension(0:nleg-1) :: msq
      real(ki), dimension(4) :: p0, k1, e1, e2
      real(ki), dimension(10) :: x1, x2
      real(ki) :: teta,MP12,A1,K1SQ,mu2,x1t,x2t,x3t,x4t,Ft
      real(ki) :: X1p,X2p,Fp,X1z,X2z,Fz,X1m,X2m,Fm,F1z,KK,Kmu,KB
      complex(ki), dimension(4) :: q1,q2,q3,q4,q5,q6,q7,q8,q9,q10
      complex(ki), dimension(4) :: e3, e4, qt
      complex(ki), dimension(10) :: x3, x4

      common/Fzip/Fp,Fz,Fm,F1z,mu2,KK,Kmu,KB,MP12

      KK=one
      KB=one
      Kmu=one

      j2=cut2/10
      j1=cut2-j2*10

      K1SQ=sdot(k1,k1)
      MP12=sdot(e1,e2)
      A1=(msq(j2)-msq(j1)-K1SQ)/two/MP12

      X1z=zip
      X2z=A1
       Fz=-msq(j1)/two/MP12

      X1p=KB
      X2p=A1-KB*K1SQ/two/MP12
       Fp=KB*X2p-msq(j1)/two/MP12

      X1m=-KB
      X2m=A1+KB*K1SQ/two/MP12
       Fm=-KB*X2m-msq(j1)/two/MP12

!--- scelta dinamica
      mu2=max(msq(j1),msq(j2),K1SQ)
      if (mu2.lt.1.0e-10_ki) mu2=one
 
!--- scelta statica
!      mu2=one

      F1z=-(msq(j1)+mu2)/two/MP12

       teta=twopi/three
       do j=1,3
       x1(j)=X1z
       x2(j)=X2z
       x4(j)=cos(teta*real(j-1,ki))+im*sin(teta*real(j-1,ki))
       x3(j)=Fz/x4(j)
       enddo
       teta=twopi/two
       do j=4,5
       x1(j)=X1z
       x2(j)=X2z
       x3(j)=cos(teta*real(j-4,ki))-im*sin(teta*real(j-4,ki))
       x4(j)=Fz/x3(j)
       enddo

       teta=twopi/two
       do j=6,7
       x1(j)=X1p
       x2(j)=X2p
       x4(j)=cos(teta*real(j-6,ki))+im*sin(teta*real(j-6,ki))
       x3(j)=Fp/x4(j)
       enddo
       x1(8)=X1p
       x2(8)=X2p
       x3(8)=cone
       x4(8)=Fp*cone

       x1(9)=X1m
       x2(9)=X2m
       x3(9)=Fm*cone
       x4(9)=cone

       x1(10)=X1z
       x2(10)=X2z
       x3(10)=F1z*cone
       x4(10)=cone

       x1t=2.3_ki
       x2t=A1-x1t*K1SQ/two/MP12
       Ft=x1t*x2t-(msq(j1)+half)/two/MP12
       x3t=(2.5_ki,0.3_ki)
       x4t=Ft/x3t

      do i=1,4
      q1(i)=-p0(i)+x1(1)*e1(i)+x2(1)*e2(i)+KK*x3(1)*e3(i)+x4(1)*e4(i)/KK
      q2(i)=-p0(i)+x1(2)*e1(i)+x2(2)*e2(i)+KK*x3(2)*e3(i)+x4(2)*e4(i)/KK
      q3(i)=-p0(i)+x1(3)*e1(i)+x2(3)*e2(i)+KK*x3(3)*e3(i)+x4(3)*e4(i)/KK
      q4(i)=-p0(i)+x1(4)*e1(i)+x2(4)*e2(i)+KK*x3(4)*e3(i)+x4(4)*e4(i)/KK
      q5(i)=-p0(i)+x1(5)*e1(i)+x2(5)*e2(i)+KK*x3(5)*e3(i)+x4(5)*e4(i)/KK
      q6(i)=-p0(i)+x1(6)*e1(i)+x2(6)*e2(i)+KK*x3(6)*e3(i)+x4(6)*e4(i)/KK
      q7(i)=-p0(i)+x1(7)*e1(i)+x2(7)*e2(i)+KK*x3(7)*e3(i)+x4(7)*e4(i)/KK
      q8(i)=-p0(i)+x1(8)*e1(i)+x2(8)*e2(i)+KK*x3(8)*e3(i)+x4(8)*e4(i)/KK
      q9(i)=-p0(i)+x1(9)*e1(i)+x2(9)*e2(i)+KK*x3(9)*e3(i)+x4(9)*e4(i)/KK
      q10(i)=-p0(i)+x1(10)*e1(i)+x2(10)*e2(i)+KK*x3(10)*e3(i) &
     & +x4(10)*e4(i)/KK
      qt(i)=-p0(i)+x1t*e1(i)+x2t*e2(i)+x3t*e3(i)+x4t*e4(i)
      enddo

  end subroutine getq2

      subroutine getq1(nleg,cut1,e1,e2,e3,e4,p0,msq,q1,q2,q3,q4,q5,qt)
      implicit none
      integer cut1,j1,i,nleg
      real(ki), dimension(0:nleg-1) :: msq
      real(ki), dimension(4) :: p0, e1, e2
      real(ki), dimension(5) :: x1, x2
      real(ki) :: MP12,G0,KK,mu2,varx,x1t,x2t,x3t,x4t
      complex(ki), dimension(4) :: q1,q2,q3,q4,q5, qt, e3, e4
      complex(ki), dimension(5) :: x3, x4

      common/FGzip/G0,KK,mu2,MP12

      KK=one
      j1=cut1

      mu2=zip
      if (msq(j1).eq.zip) then
      mu2=one
      endif

      MP12=sdot(e1,e2)
      G0=(msq(j1)+mu2)/two/MP12

      x1(1)=G0
      x2(1)=one
      x3(1)=zip
      x4(1)=zip

      x1(2)=-G0
      x2(2)=-one
      x3(2)=zip
      x4(2)=zip

      x1(3)=G0
      x2(3)=one
      x3(3)=one
      x4(3)=zip

      x1(4)=zip
      x2(4)=one
      x3(4)=-one
      x4(4)=G0

      x1(5)=zip
      x2(5)=one
      x3(5)=one
      x4(5)=-G0

      varx=-(msq(j1)+half)/two/MP12

      x1t=3.2_ki
      x2t=1.2_ki
      x3t=4.2_ki
      x4t=(varx+x1t*x2t)/x3t

      do i=1,4
      q1(i)=-p0(i)+x1(1)*e1(i)+x2(1)*e2(i)+x3(1)*e3(i)+x4(1)*e4(i)
      q2(i)=-p0(i)+x1(2)*e1(i)+x2(2)*e2(i)+x3(2)*e3(i)+x4(2)*e4(i)
      q3(i)=-p0(i)+x1(3)*e1(i)+x2(3)*e2(i)+x3(3)*e3(i)+x4(3)*e4(i)
      q4(i)=-p0(i)+x1(4)*e1(i)+x2(4)*e2(i)+x3(4)*e3(i)+x4(4)*e4(i)
      q5(i)=-p0(i)+x1(5)*e1(i)+x2(5)*e2(i)+x3(5)*e3(i)+x4(5)*e4(i)
      qt(i)=-p0(i)+x1t  *e1(i)+x2t  *e2(i)+x3t  *e3(i)+x4t  *e4(i)
      enddo

  end subroutine getq1
end module mgetqs

